unit IniFile1;

interface

Function EnumSnoopServices(Var Info:PChar;Var Proc:Pointer;Var ScanCode:Integer;Var Modifier:Integer;Var Copy:LongBool;Var Paste:LongBool;Var lParam:Longint;Var Reserved:Pointer):LongBool;Export;stdcall;


implementation

Uses Windows;

function StrLen(p:PChar):integer;
begin
  Result:=0;
  while p^<>#0 do
    begin
      inc(Result);
      inc(p);
    end;
end;

function StrLCopy(p1,p2:PChar;count:integer):integer;
begin
  Result:=StrLen(p2);
  if count<Result
    then
      Result:=Count;
  for Count:=1 to result do
    begin
      p1^:=p2^;
      inc(p2);
      inc(p1);
    end;
end;

Const LayNum=20;

var
  WinVer:TOSVersionInfo;
  p1,p2:PChar;
  I,Count:Integer;
  CfgFile:TextFile;
  Lays:array [1..LayNum,1..2] of ^String;
  Keys:array [1..LayNum] of Word;
  Modifiers:array [1..LayNum] of Word;
  Switches:array[1..LayNum] of Boolean;
  Layouts,Layout:Integer;
  S:String;

Function Toggle:Integer;
var
  ToggleKey:HKey;
  ToggleValue:Array[1..4] of Char;
  i:DWORD;
begin
  if (WinVer.dwPlatformId=VER_PLATFORM_WIN32_NT)
    then
      begin
        if (RegOpenKey(HKEY_CURRENT_USER,'Keyboard Layout\Toggle',ToggleKey)=ERROR_SUCCESS)
          then
            begin
              i:=2;
              if RegQueryValueEx(ToggleKey,'HotKey',nil,nil,@ToggleValue[1],@i)=ERROR_SUCCESS
                then
                  Result:=Ord(ToggleValue[1])-Ord('0')
                else
                  Result:=0;
              RegCloseKey(ToggleKey);
            end
          else
            Result:=0;
      end
    else
      begin
        if (RegOpenKey(HKEY_USERS,'.Default\keyboard layout\toggle',ToggleKey)=ERROR_SUCCESS)
          then
            begin
              i:=2;
              if RegQueryValueEx(ToggleKey,nil,nil,nil,@ToggleValue[1],@i)=ERROR_SUCCESS
                then
                  Result:=Ord(ToggleValue[1])-Ord('0')
                else
                  Result:=0;
              RegCloseKey(ToggleKey);
            end
          else
            Result:=0;
      end;
end;


Function SnoopTranslate(lParam,HOut:Integer;Var HIn:Integer):Longint;Stdcall;
var
  HitsOne,HitsTwo:integer;
  NewClip,Clip:THandle;
  PCh,PCh1,PCh2:PChar;
  Size:cardinal;
  I:Integer;
  CodeOne:Boolean;
  CurrentLetters:Integer;
type
  PArray=array[1..4] of WideChar;
//var PArr:^PArray;
//Arr:PArray;

begin
  Layout:=lParam;
  CurrentLetters:=0;
  Clip:=HOut;
  PCh:=GlobalLock(Clip);
  if not Assigned(PCh)
    then
      begin
        Result:=0;
        exit;
      end;
  Size:=StrLen(PCh)+1;
  NewClip:=GlobalAlloc(GMem_Moveable+GMem_DDEShare,Size);
  PCh1:=GlobalLock(NewClip);
  PCh2:=PCh1;
  inc(PCh1,Size-1);
  PCh1^:=#0;
  PCh1:=PCh2;
  StrLCopy(PCh1,PCh,Size-1);
  PCh1:=PCh;
  HitsOne:=0;
  HitsTwo:=0;
  repeat
    i:=1;
    repeat
      if PCh1^=Lays[Layout,1]^[i]
        then
          begin
            Inc(HitsOne);
            break;
          end
        else
          if PCh1^=Lays[Layout,2]^[i]
            then
              begin
                Inc(HitsTwo);
                break;
              end;
      inc(i);
    until i>Length(Lays[Layout,1]^);
    inc(PCh1);
  until PCh1^=#0;
  if HitsOne>HitsTwo
    then
      CodeOne:=True
    else
      CodeOne:=False;                                    
  if Switches[Layout]
    then
      begin
        Case Toggle of
          1:
            begin
              keybd_event(VK_MENU,$38,0,0);
              keybd_event(VK_SHIFT,$2a,0,0);
              keybd_event(VK_SHIFT,$2a,KEYEVENTF_KEYUP,0);
              keybd_event(VK_MENU,$38,KEYEVENTF_KEYUP,0);
            end;
          2:
            begin
              keybd_event(VK_SHIFT,$2a,0,0);
              keybd_event(VK_CONTROL,$1d,0,0);
              keybd_event(VK_CONTROL,$1d,KEYEVENTF_KEYUP,0);
              keybd_event(VK_SHIFT,$2a,KEYEVENTF_KEYUP,0);
            end;
        end;
      end;
  PCh1:=PCh2;
  repeat
    i:=1;
    repeat
      if CodeOne
        then
          if PCh1^=Lays[Layout,1]^[i]
            then
              begin
                PCh1^:=Lays[Layout,2]^[i];
                Inc(CurrentLetters);
                break;
              end
            else
        else
          if PCh1^=Lays[Layout,2]^[i]
            then
              begin
                PCh1^:=Lays[Layout,1]^[i];
                Inc(CurrentLetters);
                break;
              end;
      inc(i);
    until i>Length(Lays[Layout,1]^);
    inc(PCh1);
  until PCh1^=#0;
  GlobalUnlock(Clip);
  HIn:=NewClip;
  Result:=CurrentLetters;
end;

Function EnumSnoopServices(Var Info:PChar;Var Proc:Pointer;Var ScanCode:Integer;Var Modifier:Integer;Var Copy:LongBool;Var Paste:LongBool;Var lParam:Longint;Var Reserved:Pointer):LongBool;Export;
begin
  if Layout=0
    then
      Begin
        Proc:=Nil;
        Result:=False;
      end
    else
      begin
        GetMem(Info,16);
        Move(PChar(System.Copy(Lays[Layout,1]^,1,6)+'<->'+System.Copy(Lays[Layout,2]^,1,6))^,Info^,16);
        Proc:=@SnoopTranslate;
        ScanCode:=Keys[Layout];
        Modifier:=Modifiers[Layout];
        Copy:=LongBool(True);
        Paste:=LongBool(True);
        lParam:=Layout;
        Reserved:=nil;
        if Layout>1
          then
            Result:=True
          else
            Result:=False;
        Dec(Layout);
      end;
end;


initialization

  WinVer.dwOSVersionInfoSize:=SizeOf(WinVer);
  GetVersionEx(WinVer);
  GetMem(p1,266);
  Count:=GetModuleFileName(hInstance,p1,266);
  p2:=p1;
  Inc(p2,Count);
  repeat
    dec(p2);
  until p2^='\';
  inc(p2);
  StrLCopy(p2,'snoop.ini',9);
  inc(p2,9);
  p2^:=#0;
  AssignFile(CfgFile,p1);
  FreeMem(p1,266);
  {$i-}
  Reset(CfgFile);
  if IOResult<>0
    then
      Exit;
  {$i+}
  Layouts:=0;
  while not Eof(CfgFile) do
    begin
      ReadLn(CfgFile,S);
      if Copy(S,1,8)='[Layout]'
        then
          begin
            if Layouts>0
              then
                if (Assigned(Lays[Layouts,1]) and Assigned(Lays[Layouts,2])) and
                   (Length(Lays[Layouts,1]^)=Length(Lays[Layouts,1]^)) and (Length(Lays[Layouts,1]^)>0)
                   then
                     if Layouts<LayNum
                       then
                         Inc(Layouts)
                       else
                   else
                     begin
                       FreeMem(Lays[Layouts,1],Length(Lays[Layouts,1]^));
                       FreeMem(Lays[Layouts,2],Length(Lays[Layouts,2]^));
                     end
              else
                if Layouts<LayNum
                  then
                    Inc(Layouts);
          end
        else
          if (Copy(S,1,7)='Table1=') and not Assigned(Lays[Layouts,1])
            then
              begin
                GetMem(Lays[Layouts,1],Length(S)-7+1);
                Lays[Layouts,1]^:=Copy(S,8,Length(S)-7);
              end
            else
              if (Copy(S,1,7)='Table2=') and not Assigned(Lays[Layouts,2])
                then
                  begin
                    GetMem(Lays[Layouts,2],Length(S)-7+1);
                    Lays[Layouts,2]^:=Copy(S,8,Length(S)-7);
                  end
                else
                  if (Copy(S,1,4)='Key=')
                    then
                      begin
                        Keys[Layouts]:=Ord(S[5]);
                        Modifiers[Layouts]:=0;
                      end
                    else
                      if (Copy(S,1,7)='HotKey=')
                        then
                          begin
                            Modifiers[Layouts]:=0;
                            Layout:=8;
                            while not (S[Layout] in ['0'..'9']) and (Layout<Length(S)) do
                              begin
                                case S[Layout] of
                                  'S':
                                    Modifiers[Layouts]:=Modifiers[Layouts] or MOD_SHIFT;
                                  'A':
                                    Modifiers[Layouts]:=Modifiers[Layouts] or MOD_ALT;
                                  'C':
                                    Modifiers[Layouts]:=Modifiers[Layouts] or MOD_CONTROL;
                                  'W':
                                    Modifiers[Layouts]:=Modifiers[Layouts] or 8{MOD_WIN};
                                end;
                                Inc(Layout);
                              end;
                            Keys[Layouts]:=0;
                            while (S[Layout] in ['0'..'9']) and (Layout<=Length(S)) do
                              begin
                                Keys[Layouts]:=Keys[Layouts]*10+Ord(S[Layout])-Ord('0');
                                Inc(Layout);
                              end;
                          end
                        else
                          if (Copy(S,1,8)='Switch=1')
                            then
                              Switches[Layouts]:=True;
    end;
  if Layouts>0
    then
      if (Assigned(Lays[Layouts,1]) and Assigned(Lays[Layouts,2])) and
         (Length(Lays[Layouts,1]^)=Length(Lays[Layouts,1]^)) and (Length(Lays[Layouts,1]^)>0)
        then
          Inc(Layouts,0)
        else
          begin
            FreeMem(Lays[Layouts,1],Length(Lays[Layouts,1]^));
            FreeMem(Lays[Layouts,2],Length(Lays[Layouts,2]^));
          end;
  Layout:=Layouts;
  CloseFile(CfgFile);

finalization

  for I:=1 to Layouts do
    begin
      FreeMem(Lays[I,1],Length(Lays[I,1]^));
      FreeMem(Lays[I,2],Length(Lays[I,2]^));
    end;

end.


