program Snoop2;

uses Windows,
  Messages,
  ShellApi,
  u_Snoop in 'u_Snoop.pas';

{$R *.RES}

const

  LayNum=20;

var

  ThreadID,LogFile,Layouts,Layout:Integer;
  chText, chUnicodeText, chLocale:Integer;

  CurrentLetters,TotalLetters:DWORD;

  FirstStart, Recode, IconNeeded:Boolean;

  Phantom,NextClipViewer:HWnd;
  MyMenu,PluginMenu:HMenu;
  MainIcon:hIcon;
  PMyMsg:TMsg;
  PMyIconData:PNotifyIconData;
  MyWndClass:TWndClass;
  Plugins:array [1..LayNum] of TPlugIn;
  WinVer:TOSVersionInfo;
  Snoop2Key : HKey;
  Pos:TPoint;
  WinClass:Array[1..10] of Char;

  IsDiagsOn, IsIgnoreLightsOn : LongBool;

procedure SaveClipboard;
  function ReAllocate(Old:Integer):Integer;
  var
    Size:Integer;
    P:Pointer;
  begin
    Size:=GlobalSize(Old);
    p:=GlobalLock(Old);
    Result:=GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE,Size);
    CopyMemory(GlobalLock(Result),p,Size);
    GlobalUnlock(Old);
    GlobalUnlock(Result);
  end;
begin
  if OpenClipboard(0)
    then
      begin
        chText:=GetClipboardData(CF_TEXT);
        chUnicodeText:=GetClipboardData(CF_UNICODETEXT);
        chLocale:=GetClipboardData(CF_LOCALE);
        CloseClipboard;
        chText:=ReAllocate(chText);
        chUnicodeText:=ReAllocate(chUnicodeText);
        chLocale:=ReAllocate(chLocale);
      end;
end;

procedure RestoreClipboard;
begin
  if OpenClipboard(0)
    then
      begin
        EmptyClipboard;
        if chText<>0
          then
            SetClipboardData(CF_TEXT,chText);
        if chUnicodeText<>0
          then
            SetClipboardData(CF_UNICODETEXT,chUnicodeText);
        if chLocale<>0
          then
            SetClipboardData(CF_Locale,chLocale);
        CloseClipboard;
      end;
end;

procedure Translate;
var
  NewUnicodeClip,NewClip,Clip:THandle;
  PCh2,PCh3:PChar;
  Size:cardinal;
  Format:Uint;
  HLocale:Integer;
  PLocale:PInteger;
begin
  if not OpenClipboard(Phantom)
    then
      Exit;
  Format:=CF_TEXT;
  if Plugins[Layout].Copy
    then
      Clip:=GetClipboardData(Format)
    else
      Clip:=0;
  if Plugins[Layout].Copy and (Clip=0)
    then
      begin
        CloseClipboard;
        exit;
      end;
  Inc(CurrentLetters,Plugins[Layout].ProcAddress(Plugins[Layout].lParam,Clip,NewClip));
  Recode:=False;
  if Plugins[Layout].Paste
    then
      begin
        if (NewClip=0)
          then
            begin
              CloseClipboard;
              exit;
            end;
        EmptyClipboard;
        HLocale:=GlobalAlloc(GMEM_DDESHARE+GMEM_MOVEABLE,SizeOf(Integer));
        PLocale:=GlobalLock(HLocale);
        PLocale^:=GetKeyboardLayout(GetWindowThreadProcessID(GetForegroundWindow,nil)) shr 16;
        GlobalUnlock(HLocale);
        SetClipboardData(CF_LOCALE,HLocale);
        GlobalUnlock(HLocale);
        PCh2:=GlobalLock(NewClip);
        Size:=StrLen(PCh2)+1;
        NewUnicodeClip:=GlobalAlloc(GMem_Moveable+GMem_DDEShare,Size*2);
        PCh3:=GlobalLock(NewUnicodeClip);
        MultiByteToWideChar(CP_ACP,0,PCh2,-1,PWideChar(PCh3),Size);
        SetClipBoardData(CF_UNICODETEXT,NewUnicodeClip);
        GlobalUnlock(NewUnicodeClip);
        SetClipboardData(Format,NewClip);
        GlobalUnlock(NewCLip);
        CloseClipboard;
        EmulatePaste;
        SetTimer(Phantom,idtRestoreClipboard,1500,nil);
      end
    else
      begin
        CloseClipboard;
      end;
end;

procedure Statistics;
begin
  IntToPchar(CurrentLetters,@Stat[20]);
  IntToPchar(TotalLetters+CurrentLetters,@Stat[56]);
  MessageBox(0,@Stat[1],ProgramInfo,MB_OK);
end;

procedure CloseProgram;
var
  I:Integer;
begin
  For I:=1 to Layouts do
    FreeLibrary(Plugins[I].Module);
  if (RegOpenKey(HKEY_CURRENT_USER,sSoftwareSnoop,Snoop2Key)=ERROR_SUCCESS) or (RegCreateKey(HKEY_CURRENT_USER,sSoftwareSnoop,Snoop2Key)=ERROR_SUCCESS)
    then
      begin
        RegSetValueEx(Snoop2Key,sDiagsOn,0,REG_DWORD,@IsDiagsOn,4);
        RegSetValueEx(Snoop2Key,sIgnoreLightsOn,0,REG_DWORD,@IsIgnoreLightsOn,4);
        RegCloseKey(Snoop2Key);
      end;
  ChangeClipboardChain(Phantom,NextCLipViewer);
  LogFile:=CreateFile(LogFileName,GENERIC_WRITE,FILE_SHARE_READ,nil,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
  if LogFile<>INVALID_HANDLE_VALUE
    then
      begin
        Inc(TotalLetters,CurrentLetters);
        if not WriteFile(LogFile,TotalLetters,SizeOf(CurrentLetters),CurrentLetters,nil)
          then
            CurrentLetters:=GetLastError;
        CloseHandle(LogFile);
      end;
  Shell_NotifyIcon(NIM_DELETE,PMyIconData);
  DestroyMenu(MyMenu);
  if FirstStart
    then
      MessageBox(0,Payment,FirstInfo,MB_OK);
end;

procedure HotKeyProcess(iThreadVar:Integer);stdcall;
var
  I:Integer;
begin
  SaveClipboard;
        if Plugins[Layout].Copy
          then
            begin
              for I:=1 to 6 do
                begin
                  if IsModifierPressed
                    then
                      Sleep(250)
                    else
                      Break;
                  end;
              if IsModifierPressed
                then
                  begin
                    if IsDiagsOn
                      then
                        MessageBox(0,sPleaseReleaseModifiers,ProgramInfo,MB_OK);
                    Exit;
                  end;
              Recode:=True;
              SetTimer(Phantom,idtCancelRecode,3000,nil);
              EmulateCopy;
            end
          else
            Translate;
end;

function MyWndProc(wnd:HWND;message:UInt;wParam:DWORD;lParam:longint):longint;stdcall;
begin
  Result:=0;
  case message of
    WM_CLOSE:
      begin
        PostQuitMessage(0);
      end;
    WM_COMMAND:
      begin
        case LoWord(wParam) of
          idmExit:
            PostQuitMessage(0);
          idmAbout :
            ShellAbout(Phantom,ProgramInfo,ProgrammerInfo,MainIcon);
          idmStatistics :
            Statistics;
          idmMessages:
            begin
              IsDiagsOn:=not IsDiagsOn;
              if IsDiagsOn
                then
                  CheckMenuItem(MyMenu,idmMessages,MF_BYCOMMAND+MF_CHECKED)
                else
                  CheckMenuItem(MyMenu,idmMessages,MF_BYCOMMAND+MF_UNCHECKED)
            end;
          idmIgnoreLights:
            begin
              IsIgnoreLightsOn:=not IsIgnoreLightsOn;
              if IsIgnoreLightsOn
                then
                  CheckMenuItem(MyMenu,idmIgnoreLights,MF_BYCOMMAND+MF_CHECKED)
                else
                  CheckMenuItem(MyMenu,idmIgnoreLights,MF_BYCOMMAND+MF_UNCHECKED)
            end;
          idmReinstallHook:
            begin
              ChangeClipboardChain(Phantom,NextClipViewer);
              NextClipViewer:=SetClipboardViewer(Phantom);
            end;
        end;
        if HiWord(wParam)=0
          then
          else
            Result:=DefWindowProc(Wnd,Message,wParam,lParam);
        if LoWord(wParam)>idmPluginBase then
          begin
            Layout:=LoWord(wParam)-idmPluginBase;
            SendMessage(Phantom,WM_MYHOTKEYRESET,Layout,0);
          end;
      end;
    WM_MYTRAYMSG:
      begin
        if (lParam=WM_RBUTTONUP)
          then
            begin
              GetCursorPos(Pos);
              SetWindowPos(Phantom,0,Pos.X,Pos.Y,0,0,SWP_NOSIZE+SWP_NOZORDER+SWP_NOREDRAW);
              SetForegroundWindow(Phantom);
              if MyMenu=0
                then
                  Beep(440,100);
              TrackPopupMenu(MyMenu,TPM_LEFTALIGN+TPM_RIGHTALIGN+TPM_CENTERALIGN+TPM_RIGHTBUTTON,Pos.x,Pos.y,0,Phantom,nil);
              PostMessage(Phantom,WM_USER,0,0);
            end;
      end;
    WM_MYEXITMSG:
      begin
        PostQuitMessage(0);
        Result:=-1;
      end;
    WM_DRAWCLIPBOARD:
      begin
        KillTimer(Phantom,idtCancelRecode);
        SendMessage(NextClipViewer,WM_DRAWCLIPBOARD,0,0);
        if Recode
          then
            Translate;
      end;
    WM_CHANGECBCHAIN:
      begin
        if wParam=NextClipViewer
          then
            NextClipViewer:=HWND(lParam)
          else
            SendMessage(NextClipViewer,WM_CHANGECBCHAIN,wParam,lParam);
      end;
    WM_HOTKEY:
      begin
        if (WinVer.dwPlatformId<>VER_PLATFORM_WIN32_NT) and (GetClassName(GetForegroundWindow,@WinClass[1],SizeOf(WinClass))<>0) and (StrComp(@WinClass,ConsoleWndClassName)=0)
          then
            begin
              Recode:=False;
              Exit;
            end;
        Layout:=wParam;
        if IsIgnoreLightsOn or (CreateThread(nil,0,@HotKeyProcess,nil,0,ThreadID)=0)
          then
            HotKeyProcess(0);
      end;
    WM_MYHOTKEYRESET:
      begin
        if not Plugins[Layout].Enabled
          then
            begin
              if RegisterHotKey(Phantom,Layout,Plugins[Layout].Modifiers,Plugins[Layout].ScanCode)
                then
                  begin
                    CheckMenuItem(PluginMenu,LayOut+idmPluginBase,MF_BYCOMMAND+MF_CHECKED);
                    Plugins[LayOut].Enabled:=True;
                  end
                else
                  MessageBox(0,sPluginRegisterHotKeyFailed,Plugins[Layout].Info,MB_OK);
            end
          else
            begin
              UnRegisterHotKey(Phantom,Layout);
              CheckMenuItem(PluginMenu,LayOut+idmPluginBase,MF_BYCOMMAND+MF_UNCHECKED);
              Plugins[LayOut].Enabled:=False;
            end;
      end;
    WM_ENDSESSION:
      begin
        if Boolean(wParam)=True
          then
            CloseProgram;
      end;
    WM_TIMER:
      begin
        case wParam of
          idtCancelRecode:
            begin
              Recode:=False;
              KillTimer(Phantom,wParam);
              if IsDiagsOn
                then
                  if MessageBox(0,sCopyTextTimeOutExpired,ProgramInfo,MB_YESNOCANCEL)=idYes
                    then
                      PostMessage(Phantom,WM_COMMAND,MakeWord(idmReinstallHook,0),0);
            end;
          idtRestoreClipboard:
            begin
              KillTimer(Phantom,idtRestoreClipboard);
              RestoreClipboard;
            end;
         end;
      end;
    else
      begin
        Result:=DefWindowProc(Wnd,message,wParam,lParam);
      end;
  end;
end;

procedure AppendServiceMenu(Info:PChar;LayOut,Key:Integer);
var
  MenuCaption:PChar;
begin
  MenuCaption:=Info;
  AppendMenu(PluginMenu,MF_STRING+MF_CHECKED,LayOut+idmPluginBase,MenuCaption);
end;

Procedure SearchForPlugins;
Var
  FindData:TWin32FindData;
  H:Integer;
  Module:Integer;
  EnumProc:TEnumSnoopServices;
  CommandLine, PC : PChar;
begin
  PluginMenu:=CreatePopupMenu;
  CommandLine:=GetCommandLine;
  PC:=CommandLine;
  if Assigned(PC) then
    begin
      if PC^='"'
        then
          repeat
            inc(PC)
          until PC^='"'
        else
          repeat
            inc(PC)
          until (PC^=' ') or (PC^=#0);
      Repeat
        Dec(PC)
      until (PC^='\') or (PC=CommandLine);
      if PC^='\'
        then
          Inc(PC);
      Move(sPluginFileMask^,PC^,Length(sPluginFileMask)+1)
    end;
  Layout:=0;
  if CommandLine^='"'
    then
      Inc(CommandLine);
  H:=FindFirstFile(CommandLine,FindData);
  while (H<>INVALID_HANDLE_VALUE) do
    begin
      Module:=LoadLibrary(FindData.cFileName);
      if Module<>0
        then
          begin
            EnumProc:=GetProcAddress(Module,sEnumSnoopServicesProcName);
            if not Assigned(EnumProc)
              then
                FreeLibrary(Module)
              else
                begin
                  Inc(Layout);
                  Plugins[LayOut].Module:=Module;
                  Plugins[LayOut].Enabled:=True;
                  while EnumProc(Plugins[LayOut].Info,Plugins[LayOut].ProcAddress,Plugins[LayOut].ScanCode,Plugins[LayOut].Modifiers,Plugins[LayOut].Copy,Plugins[LayOut].Paste,Plugins[LayOut].lParam,Plugins[LayOut].Reserved) do
                    begin
                      if Assigned(Plugins[LayOut].ProcAddress)
                        then
                          begin
                            AppendServiceMenu(Plugins[Layout].Info,LayOut,Plugins[Layout].ScanCode);
                            Inc(LayOut);
                          end;
                    end;
                  if not Assigned(Plugins[LayOut].ProcAddress)
                    then
                      begin
                        Dec(LayOut);
                        FreeLibrary(Plugins[LayOut].Module);
                      end
                    else
                      AppendServiceMenu(Plugins[Layout].Info,LayOut,Plugins[Layout].ScanCode);
                end;
          end;
      if not FindNextFile(H,FindData)
        then
          Break;
    end;
  Windows.FindClose(H);
  Layouts:=Layout;
end;

begin
  IconNeeded:=ParamCount=0;
  SendMessage(FindWindow(MyClassName,nil),WM_MYEXITMSG,0,0);
  SearchForPlugins;
  if Layouts=0
    then
      QuitForNoPlugins;
  TotalLetters:=0;
  GetVersionEx(WinVer);
  LogFile:=CreateFile(LogFileName,GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if LogFile<>INVALID_HANDLE_VALUE
    then
      begin
        if not ReadFile(LogFile,TotalLetters,SizeOf(CurrentLetters),CurrentLetters,nil) or (TotalLetters<0)
          then
            TotalLetters:=0;
        CloseHandle(LogFile);
        FirstStart:=False;
      end
    else
      begin
        FirstStart:=True;
        MessageBox(0,Info,FirstInfo,MB_OK);
      end;
  CurrentLetters:=0;
  FillChar(MyWndClass,SizeOf(MyWndClass),0);
  with MyWndClass do
    begin
      lpfnWndProc:=@MyWndProc;
      lpszClassName:=MyClassName;
    end;
  MyWndClass.hInstance:=hInstance;
  RegisterClass(MyWndClass);
  Phantom:=CreateWindow(MyWndClass.lpszClassName,nil,0,0,0,0,0,0,0,HInstance,nil);
  if Phantom=0
    then
      Halt;
  NextClipViewer:=SetClipboardViewer(Phantom);
  IsDiagsOn:=True;
  IsIgnoreLightsOn:=True;
  if (RegOpenKey(HKEY_CURRENT_USER,sSoftwareSnoop,Snoop2Key)=ERROR_SUCCESS)
    then
      begin
        Layout:=4;
        RegQueryValueEx(Snoop2Key,sDiagsOn,nil,nil,@IsDiagsOn,@Layout);
        RegQueryValueEx(Snoop2Key,sIgnoreLightsOn,nil,nil,@IsIgnoreLightsOn,@Layout);
        RegCloseKey(Snoop2Key);
      end;
  for Layout:=1 to Layouts do
    if not RegisterHotKey(Phantom,Layout,Plugins[Layout].Modifiers,Plugins[Layout].ScanCode)
      then
        begin
          if isDiagsOn
            then
              MessageBox(0,sPluginRegisterHotKeyFailed,Plugins[Layout].Info,MB_OK);
          Plugins[Layout].Enabled:=False;
          CheckMenuItem(PluginMenu,LayOut+idmPluginBase,MF_BYCOMMAND+MF_UNCHECKED);
        end
      else
        begin
          Plugins[Layout].Enabled:=True;
        end;
  MyMenu:=CreatePopupMenu;
  if MyMenu=0
    then
      exit;
  AppendMenu(MyMenu,MF_STRING,idmMessages,msMessages);
  AppendMenu(MyMenu,MF_STRING,idmIgnoreLights,msIgnoreLights);
  AppendMenu(MyMenu,MF_POPUP,PluginMenu,msAboutPlugins);
  AppendMenu(MyMenu,MF_STRING,0,nil);
  AppendMenu(MyMenu,MF_STRING,idmAbout,msAboutProgram);
  AppendMenu(MyMenu,MF_STRING,idmStatistics,msStatistics);
  AppendMenu(MyMenu,MF_STRING,idmReinstallHook,msReinstallHook);
  AppendMenu(MyMenu,MF_STRING,idmExit,msExit);
  if IsDiagsOn
    then
      CheckMenuItem(MyMenu,idmMessages,MF_BYCOMMAND+MF_CHECKED)
    else
      CheckMenuItem(MyMenu,idmMessages,MF_BYCOMMAND+MF_UNCHECKED);
  if IsIgnoreLightsOn
    then
      CheckMenuItem(MyMenu,idmIgnoreLights,MF_BYCOMMAND+MF_CHECKED)
    else
      CheckMenuItem(MyMenu,idmIgnoreLights,MF_BYCOMMAND+MF_UNCHECKED);
  New(PMyIconData);
  MainIcon:=LoadIcon(HInstance,sMAINICON);
  with PMyIconData^ do
    begin
      cbSize:=SizeOf(TNotifyIconData);
      Wnd:=Phantom;
      uId:=1;
      uFlags:=NIF_ICON+NIF_TIP+NIF_MESSAGE;
      uCallBackMessage:=WM_MYTRAYMSG;
      hIcon:=LoadIcon(HInstance,sTRAYICON);
      Move(sTrayHint^,szTip[0],Length(sTrayHint)+1);
    end;
  if IconNeeded
    then
      if not Shell_NotifyIcon(NIM_ADD,PMyIconData)
        then
          Shell_NotifyIcon(NIM_MODIFY,PMyIconData);
  while GetMessage(PMyMsg,0,0,0) do
    begin
      DispatchMessage(PMyMsg);
    end;
  CloseProgram;
end.
